// _advanced expert advisor template v9.1219.mq4
// Copyright  2009, TradingSystemForex.Com
// http://www.tradingsystemforex.com/

#property copyright "Copyright  2009, TradingSystemForex.Com"
#property link "http://www.tradingsystemforex.com/"

extern string comment="EA";              // comment to display in the order
extern int magic=1234;                   // magic number required if you use different settings on a same pair, same timeframe

extern string moneymanagement="Money Management";

extern double lots=0.1;                  // lots size
extern bool mm=false;                    // enable risk management
//extern int mmmode=0;                     // 0=freemargin, 1=equity, 2=balance
extern double risk=1;                    // risk in percentage of the account
extern double minlot=0.01;               // minimum lots size
extern double maxlot=50;                 // maximum lots size
extern double lotdigits=2;               // lot digits, 1 for mini, 2 for micro
//extern bool martingale=false;            // enable the martingale
//extern double multiplier=2.0;            // multiplier used for the martingale
//extern bool basketpercent=false;         // enable the basket percent
//extern double profit=10;                 // close all orders if a profit of 10 percents has been reached
//extern double loss=30;                   // close all orders if a loss of 30 percents has been reached

extern string ordersmanagement="Order Management";

extern bool ecn=false;                   // make the expert compatible with ecn brokers
extern bool oppositeclose=false;          // close the orders on an opposite signal
extern bool reversesignals=false;        // reverse the signals, long if short, short if long
extern int maxtrades=100;                // maximum trades allowed by the traders
extern int tradesperbar=1;               // maximum trades per bar allowed by the expert
extern bool hidesl=false;                // hide stop loss
extern bool hidetp=false;                // hide take profit
extern double stoploss=0;                // stop loss
extern double takeprofit=0;              // take profit
extern double trailingstart=0;           // profit in pips required to enable the trailing stop
extern double trailingstop=0;            // trailing stop
extern double trailingprofit=0;          // trailing profit
extern double trailingstep=1;            // margin allowed to the market to enable the trailing stop
extern double breakevengain=0;           // gain in pips required to enable the break even
extern double breakeven=0;               // break even
int expiration=0;                 // expiration in minutes for pending orders
double slippage=0;                // maximum difference in pips between signal and order
extern double maxspread=100;             // maximum spread allowed by the expert

extern string braintrend2sig="BrainTrend2Sig Entry Settings";

extern bool bt2sentry=true;
extern int numbars=500;
extern int bt2sshift=1;                      // bar in the past to take in consideration for the signal

extern string cciwoodies="CCIWoodies Entry Settings";

extern bool cciwentry=true;
extern int fastPeriod=6;
extern int slowPeriod=14;
extern int histLength=300;
extern int step=0;
extern int cciwshift=1;

extern string cciwoodies2="CCIWoodies Exit Settings";

extern bool cciwexit=true;
extern int fastPeriod2=6;
extern int slowPeriod2=14;
extern int histLength2=300;
extern int step2=0;
extern int cciwshift2=1;

extern string nonlagama="NonLagAMA Exit Settings";

extern bool nlamaexit=true;
extern int Price=0;
extern int Length=12;
extern int Displace=0;
extern int Filter=0;
extern int Color=1;
extern int ColorBarBack=1;
extern double Deviation=0.0;
extern int nlamashift=1;

extern string chandelier="ChandelierStops Filter Settings";

extern bool csfilter=true;
extern int Length2=15;
extern int ATRperiod=14;
extern double Kv=4;
extern int Shift=1;
extern int csshift=1;

extern string ccwoodieslnx="CCIWoodies Lnx Filter Settings";

extern bool cciwlfilter=true;
extern int TrendCCI_Period=14;
extern int EntryCCI_Period=6;
extern int LSMAPeriod=25;     
extern int EMAPeriod=34; 
extern int Trend_period=5;
extern int ccwlshift=1;

/*
extern string timefilter="Time Filter";

extern int summergmtshift=2;             // gmt offset of the broker
extern int wintergmtshift=1;             // gmt offset of the broker
extern bool mondayfilter=false;          // enable special time filter on friday
extern int mondayhour=12;                // stop to trade after this hour
extern int mondayminute=0;               // minutes of the friday hour
extern bool weekfilter=false;            // enable time filter
extern int starthour=7;                  // start hour to trade after this hour
extern int startminute=0;                // minutes of the start hour
extern int endhour=21;                   // stop to trade after this hour
extern int endminute=0;                  // minutes of the start hour
extern bool tradesunday=true;            // trade on sunday
extern bool fridayfilter=false;          // enable special time filter on friday
extern int fridayhour=12;                // stop to trade after this hour
extern int fridayminute=25;              // minutes of the friday hour
*/
datetime t0,t1,tstart,tend,tfriday,tmonday,lastbuyopentime,lastsellopentime;
int i,bc=-1,cnt,tpb,tps,tries=100,lastorder,buyorderprofit,sellorderprofit;
int nstarthour,nendhour,nfridayhour,nmondayhour,number,ticket,gmtshift;
string istarthour,istartminute,iendhour,iendminute,ifridayhour,ifridayminute,imondayhour,imondayminute;
double cb,sl,tp,ilots,lastbuylot,lastselllot,lastlot,lastprofit,mlots,win[14],sum[14];
double lastbuyopenprice,lastsellopenprice,lastbuyprofit,lastsellprofit;

bool closebasket=false;

datetime time1,time2,time3,time4,time5,time6;
double pt,mt;
int dg;

int init(){
   t0=Time[0];
   t1=Time[0];
/*
   sum[2012-1999]=D'2012.03.28 02:00:00';win[2012-1999]=D'2012.10.31 03:00:00';
   sum[2011-1999]=D'2011.03.29 02:00:00';win[2011-1999]=D'2011.10.25 03:00:00';
   sum[2010-1999]=D'2010.03.30 02:00:00';win[2010-1999]=D'2010.10.26 03:00:00';
   sum[2009-1999]=D'2009.03.29 02:00:00';win[2009-1999]=D'2009.10.25 03:00:00';
   sum[2008-1999]=D'2008.03.30 02:00:00';win[2008-1999]=D'2008.10.26 03:00:00';
   sum[2007-1999]=D'2007.03.25 02:00:00';win[2007-1999]=D'2007.10.28 03:00:00';
   sum[2006-1999]=D'2006.03.26 02:00:00';win[2006-1999]=D'2006.10.29 03:00:00';
   sum[2005-1999]=D'2005.03.27 02:00:00';win[2005-1999]=D'2005.10.30 03:00:00';
   sum[2004-1999]=D'2004.03.28 02:00:00';win[2004-1999]=D'2004.10.31 03:00:00';
   sum[2003-1999]=D'2003.03.30 02:00:00';win[2003-1999]=D'2003.10.26 03:00:00';
   sum[2002-1999]=D'2002.03.31 02:00:00';win[2002-1999]=D'2002.10.27 03:00:00';
   sum[2001-1999]=D'2001.03.25 02:00:00';win[2001-1999]=D'2001.10.28 03:00:00';
   sum[2000-1999]=D'2000.03.26 02:00:00';win[2000-1999]=D'2000.10.29 03:00:00';
   sum[1999-1999]=D'1999.03.28 02:00:00';win[1999-1999]=D'1999.10.31 03:00:00';
*/
   dg=Digits;
   if(dg==3 || dg==5){pt=Point*10;mt=10;}else{pt=Point;mt=1;}
   return(0);
}

int start(){
/*
   GlobalVariableSet("vGrafBalance",AccountBalance());
   GlobalVariableSet("vGrafEquity",AccountEquity());
*/

   if(breakevengain>0)movebreakeven(breakevengain,breakeven);
   if(trailingstop>0)movetrailingstop(trailingstart,trailingstop);
   if(trailingprofit>0)movetrailingprofit(trailingstart,trailingprofit);
/*
   if(basketpercent){
      if(closebasket==false)closebasket=closebasketpercent(profit,loss);
      if(closebasket){closebuy();closesell();delete(OP_BUYSTOP);delete(OP_SELLSTOP);delete(OP_BUYLIMIT);delete(OP_SELLLIMIT);}
      if(closebasket && count(OP_BUY)+count(OP_SELL)+count(OP_BUYLIMIT)+count(OP_SELLLIMIT)+count(OP_BUYSTOP)+count(OP_SELLSTOP)==0)closebasket=false;
   }*/
/*
   lastbuylot=0;
   lastselllot=0;
   lastorder=0;

   if(OrdersHistoryTotal()>0){
      for(i=0;i<OrdersHistoryTotal();i++){
         OrderSelect(i,SELECT_BY_POS,MODE_HISTORY);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic){
            lastprofit=OrderProfit();
            lastlot=OrderLots();
            if(OrderType()==OP_BUY){
               lastbuyprofit=OrderProfit();
               lastbuylot=OrderLots();
               lastorder=1;
            }
            if(OrderType()==OP_SELL){
               lastsellprofit=OrderProfit();
               lastselllot=OrderLots();
               lastorder=2;
            }
         }
      }
   }
   mlots=0;
   if(martingale && lastprofit<0)mlots=lastlot*multiplier;else mlots=lots;
*/
   if(OrdersTotal()>0){
      for(i=0;i<OrdersTotal();i++){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderCloseTime()==0){
            if(OrderType()==OP_BUY){
               lastbuyopentime=OrderOpenTime();
               //lastbuyopenprice=OrderOpenPrice();
               //buyorderprofit=OrderProfit();
            }
            if(OrderType()==OP_SELL){
               lastsellopentime=OrderOpenTime();
               //lastsellopenprice=OrderOpenPrice();
               //sellorderprofit=OrderProfit();
            }
         }
      }
   }
   if(tradesperbar==1){
      if(lastbuyopentime<Time[0])tpb=0;else tpb=1;
      if(lastsellopentime<Time[0])tps=0;else tps=1;
   }
   if(tradesperbar!=1 && bc!=Bars){tpb=0;tps=0;bc=Bars;}
   
   if(bt2sentry /*&& time1!=Time[0] || bt2sshift==0*/){
      double bt2su=iCustom(NULL,0,"BrainTrend2Sig",numbars,0,bt2sshift);
      double bt2sd=iCustom(NULL,0,"BrainTrend2Sig",numbars,1,bt2sshift);
      //time1=Time[0];
   }
   if(cciwentry /*&& time2!=Time[0] || cciwshift==0*/){
      double cciw0=iCustom(NULL,0,"CCI_Woodies_Paterns_v1",fastPeriod,slowPeriod,histLength,"",step,0,cciwshift);
      double cciw1=iCustom(NULL,0,"CCI_Woodies_Paterns_v1",fastPeriod,slowPeriod,histLength,"",step,1,cciwshift);
      double cciw2=iCustom(NULL,0,"CCI_Woodies_Paterns_v1",fastPeriod,slowPeriod,histLength,"",step,2,cciwshift);
      double cciw3=iCustom(NULL,0,"CCI_Woodies_Paterns_v1",fastPeriod,slowPeriod,histLength,"",step,3,cciwshift);
      double cciw4=iCustom(NULL,0,"CCI_Woodies_Paterns_v1",fastPeriod,slowPeriod,histLength,"",step,4,cciwshift);
      double cciw5=iCustom(NULL,0,"CCI_Woodies_Paterns_v1",fastPeriod,slowPeriod,histLength,"",step,5,cciwshift);
      double cciw6=iCustom(NULL,0,"CCI_Woodies_Paterns_v1",fastPeriod,slowPeriod,histLength,"",step,6,cciwshift);
      double cciw7=iCustom(NULL,0,"CCI_Woodies_Paterns_v1",fastPeriod,slowPeriod,histLength,"",step,7,cciwshift);
      //time2=Time[0];
   }
   if(cciwexit /*&& time3!=Time[0] || cciwshift2==0*/){
      double cciw02=iCustom(NULL,0,"CCI_Woodies_Paterns_v1",fastPeriod2,slowPeriod2,histLength2,"",step2,0,cciwshift2);
      double cciw12=iCustom(NULL,0,"CCI_Woodies_Paterns_v1",fastPeriod2,slowPeriod2,histLength2,"",step2,1,cciwshift2);
      double cciw22=iCustom(NULL,0,"CCI_Woodies_Paterns_v1",fastPeriod2,slowPeriod2,histLength2,"",step2,2,cciwshift2);
      double cciw32=iCustom(NULL,0,"CCI_Woodies_Paterns_v1",fastPeriod2,slowPeriod2,histLength2,"",step2,3,cciwshift2);
      double cciw42=iCustom(NULL,0,"CCI_Woodies_Paterns_v1",fastPeriod2,slowPeriod2,histLength2,"",step2,4,cciwshift2);
      double cciw52=iCustom(NULL,0,"CCI_Woodies_Paterns_v1",fastPeriod2,slowPeriod2,histLength2,"",step2,5,cciwshift2);
      double cciw62=iCustom(NULL,0,"CCI_Woodies_Paterns_v1",fastPeriod2,slowPeriod2,histLength2,"",step2,6,cciwshift2);
      double cciw72=iCustom(NULL,0,"CCI_Woodies_Paterns_v1",fastPeriod2,slowPeriod2,histLength2,"",step2,7,cciwshift2);
      //time3=Time[0];
   }
   if(nlamaexit /*&& time4!=Time[0] || nlamashift==0*/){
      double nlamau=iCustom(NULL,0,"NonLagAMA",Price,Length,Displace,Filter,Color,ColorBarBack,Deviation,0,nlamashift);
      double nlamad=iCustom(NULL,0,"NonLagAMA",Price,Length,Displace,Filter,Color,ColorBarBack,Deviation,1,nlamashift);
      double nlamaua=iCustom(NULL,0,"NonLagAMA",Price,Length,Displace,Filter,Color,ColorBarBack,Deviation,0,nlamashift+1);
      double nlamada=iCustom(NULL,0,"NonLagAMA",Price,Length,Displace,Filter,Color,ColorBarBack,Deviation,1,nlamashift+1);
      //time4=Time[0];
   }
   if(csfilter /*&& time5!=Time[0] || csshift==0*/){
      double csu=iCustom(NULL,0,"ChandelierStops_v1",Length2,ATRperiod,Kv,Shift,0,csshift);
      double csd=iCustom(NULL,0,"ChandelierStops_v1",Length2,ATRperiod,Kv,Shift,1,csshift);
      //time5=Time[0];
   }
   if(cciwlfilter /*&& time6!=Time[0] || ccwlshift==0*/){
      double cciwl=iCustom(NULL,0,"CCI_Woodies_Lnx_v6",TrendCCI_Period,EntryCCI_Period,LSMAPeriod,EMAPeriod,Trend_period,5,ccwlshift);
      //time6=Time[0];
   }
   
   int bt2signal=0;
   if(bt2su>0 && bt2su!=EMPTY_VALUE)bt2signal=1;
   if(bt2sd>0 && bt2sd!=EMPTY_VALUE)bt2signal=2;
   
   int cciwsignala=0;
   int cciwsignalb=0;
   if((cciw0!=EMPTY_VALUE && cciw0<High[cciwshift]) || (cciw1!=EMPTY_VALUE && cciw1<High[cciwshift])
   || (cciw2!=EMPTY_VALUE && cciw2<High[cciwshift]) || (cciw3!=EMPTY_VALUE && cciw3<High[cciwshift])
   || (cciw4!=EMPTY_VALUE && cciw4<High[cciwshift]) || (cciw5!=EMPTY_VALUE && cciw5<High[cciwshift])
   || (cciw6!=EMPTY_VALUE && cciw6<High[cciwshift]) || (cciw7!=EMPTY_VALUE && cciw7<High[cciwshift]))cciwsignala=1;
   if((cciw0!=EMPTY_VALUE && cciw0>Low[cciwshift]) || (cciw1!=EMPTY_VALUE && cciw1>Low[cciwshift])
   || (cciw2!=EMPTY_VALUE && cciw2>Low[cciwshift]) || (cciw3!=EMPTY_VALUE && cciw3>Low[cciwshift])
   || (cciw4!=EMPTY_VALUE && cciw4>Low[cciwshift]) || (cciw5!=EMPTY_VALUE && cciw5>Low[cciwshift])
   || (cciw6!=EMPTY_VALUE && cciw6>Low[cciwshift]) || (cciw7!=EMPTY_VALUE && cciw7>Low[cciwshift]))cciwsignalb=2;
   
   int cciwsignal2a=0;
   int cciwsignal2b=0;
   if((cciw02!=EMPTY_VALUE && cciw02<High[cciwshift2]) || (cciw12!=EMPTY_VALUE && cciw12<High[cciwshift2])
   || (cciw22!=EMPTY_VALUE && cciw22<High[cciwshift2]) || (cciw32!=EMPTY_VALUE && cciw32<High[cciwshift2])
   || (cciw42!=EMPTY_VALUE && cciw42<High[cciwshift2]) || (cciw52!=EMPTY_VALUE && cciw52<High[cciwshift2])
   || (cciw62!=EMPTY_VALUE && cciw62<High[cciwshift2]) || (cciw72!=EMPTY_VALUE && cciw72<High[cciwshift2]))cciwsignal2a=1;
   if((cciw02!=EMPTY_VALUE && cciw02>Low[cciwshift2]) || (cciw12!=EMPTY_VALUE && cciw12>Low[cciwshift2])
   || (cciw22!=EMPTY_VALUE && cciw22>Low[cciwshift2]) || (cciw32!=EMPTY_VALUE && cciw32>Low[cciwshift2])
   || (cciw42!=EMPTY_VALUE && cciw42>Low[cciwshift2]) || (cciw52!=EMPTY_VALUE && cciw52>Low[cciwshift2])
   || (cciw62!=EMPTY_VALUE && cciw62>Low[cciwshift2]) || (cciw72!=EMPTY_VALUE && cciw72>Low[cciwshift2]))cciwsignal2b=2;
   
   bool buy=false;
   bool sell=false;

   if((bt2sentry==false || (bt2sentry && bt2signal==1))
   || (cciwentry==false || (cciwentry && cciwsignala==1))
   && (csfilter==false || (csfilter && csu>0 && csu!=EMPTY_VALUE))
   && (cciwlfilter==false || (cciwlfilter && cciwl>0))
   ){if(reversesignals)sell=true;else buy=true;}
   
   if((bt2sentry==false || (bt2sentry && bt2signal==2))
   || (cciwentry==false || (cciwentry && cciwsignalb==2))
   && (csfilter==false || (csfilter && csd>0 && csd!=EMPTY_VALUE))
   && (cciwlfilter==false || (cciwlfilter && cciwl<0))
   ){if(reversesignals)buy=true;else sell=true;}

   //Comment("\nnlamaua = "+DoubleToStr(nlamaua,5),"\nnlamau = "+DoubleToStr(nlamau,5));

   if((oppositeclose && sell)
   || (nlamaexit && !buy && (nlamaua==EMPTY_VALUE && nlamau!=EMPTY_VALUE) || (nlamada==EMPTY_VALUE && nlamad!=EMPTY_VALUE))
   || (reversesignals==false && cciwexit && cciwsignal2b==2)
   || (reversesignals && cciwexit && cciwsignal2a==1))closebuy();
   
   if((oppositeclose && buy)
   || (nlamaexit && !sell && (nlamaua==EMPTY_VALUE && nlamau!=EMPTY_VALUE) || (nlamada==EMPTY_VALUE && nlamad!=EMPTY_VALUE))
   || (reversesignals==false && cciwexit && cciwsignal2a==1)
   || (reversesignals && cciwexit && cciwsignal2b==2))closesell();

   if(hidetp || hidesl){hideclosesell();hideclosebuy();}

   if((Ask-Bid)>maxspread*mt*pt)return(0);
   if((count(OP_BUY)+count(OP_SELL))>=maxtrades)return(0);

   if(mm /*&& (martingale==false || (martingale && lastprofit>=0))*/)lots=lotsoptimized();

   int expire=0;
   if(expiration>0)expire=TimeCurrent()+(expiration*60)-5;

   ticket=0;
   number=0;
   if(buy && tpb<tradesperbar){
      /*if(martingale)ilots=mlots;else*/ ilots=lots;
      if(ecn==false){
         while(ticket<=0 && number<tries /*&& checktime()*/){
            while(!IsTradeAllowed())Sleep(5000);
            RefreshRates();
            ticket=open(OP_BUY,ilots,Ask,stoploss,takeprofit,expire,Blue);
            if(ticket<0){
               //Print("Error opening BUY order! ",errordescription(GetLastError()));
               number++;
            }
         }
      }
      if(ecn){
         while(ticket<=0 && number<tries /*&& checktime()*/){
            while(!IsTradeAllowed())Sleep(5000);
            RefreshRates();
            ticket=open(OP_BUY,ilots,Ask,0,0,expire,Blue);
            if(ticket<0){
               //Print("Error opening BUY order! ",errordescription(GetLastError()));
               number++;
            }
         }
         createlstoploss(stoploss);
         createltakeprofit(takeprofit);
      }
      if(ticket<=0){/*Print("Error Occured : "+errordescription(GetLastError()));*/}else tpb++;
   }
   ticket=0;
   if(sell && tps<tradesperbar){
      /*if(martingale)ilots=mlots;else*/ ilots=lots;
      if(ecn==false){
         while(ticket<=0 && number<tries /*&& checktime()*/){
            while(!IsTradeAllowed())Sleep(5000);
            RefreshRates();
            ticket=open(OP_SELL,ilots,Bid,stoploss,takeprofit,expire,Red);
            if(ticket<0){
               //Print("Error opening BUY order! ",errordescription(GetLastError()));
               number++;
            }
         }
      }
      if(ecn){
         while(ticket<=0 && number<tries /*&& checktime()*/){
            while(!IsTradeAllowed())Sleep(5000);
            RefreshRates();
            ticket=open(OP_SELL,ilots,Bid,0,0,expire,Red);
            if(ticket<0){
               //Print("Error opening BUY order! ",errordescription(GetLastError()));
               number++;
            }
         }
         createsstoploss(stoploss);
         createstakeprofit(takeprofit);
      }
      if(ticket<=0){/*Print("Error Occured : "+errordescription(GetLastError()));*/}else tps++;
   }
   if(ecn){
      createlstoploss(stoploss);
      createltakeprofit(takeprofit);
      createsstoploss(stoploss);
      createstakeprofit(takeprofit);
   }
   return(0);
}

//|---------open

int open(int type,double lots,double price,double stoploss,double takeprofit,int expire,color clr){
   int ticket=0;
   lots=NormalizeDouble(lots,lotdigits);
   if(lots<minlot)lots=minlot;
   if(lots>maxlot)lots=maxlot;
   if(type==OP_BUY || type==OP_BUYSTOP || type==OP_BUYLIMIT){
      if(hidesl==false && stoploss>0){sl=price-stoploss*pt;}else{sl=0;}
      if(hidetp==false && takeprofit>0){tp=price+takeprofit*pt;}else{tp=0;}
   }
   if(type==OP_SELL || type==OP_SELLSTOP || type==OP_SELLLIMIT){
      if(hidesl==false && stoploss>0){sl=price+stoploss*pt;}else{sl=0;}
      if(hidetp==false && takeprofit>0){tp=price-takeprofit*pt;}else{tp=0;}
   }
   ticket=OrderSend(Symbol(),type,lots,price,slippage*mt,sl,tp,comment+". Magic: "+DoubleToStr(magic,0),magic,expire,clr);
   return(ticket);
}

//|---------lots optimized

double lotsoptimized(){
   double lot;
   if(stoploss>0)lot=AccountBalance()*(risk/100)/(stoploss*pt/MarketInfo(Symbol(),MODE_TICKSIZE)*MarketInfo(Symbol(),MODE_TICKVALUE));
   else lot=NormalizeDouble((AccountBalance()/1000)*minlot*risk,lotdigits);
   //lot=AccountFreeMargin()/(100.0*(NormalizeDouble(MarketInfo(Symbol(),MODE_MARGINREQUIRED),4)+5.0)/risk)-0.05;
   return(lot);
}

//|---------time filter
/*
int checktime(){
   if(TimeCurrent()<win[TimeYear(TimeCurrent())-1999] && TimeCurrent()>sum[TimeYear(TimeCurrent())-1999])gmtshift=summergmtshift;
   else gmtshift=wintergmtshift;
   
   string time="";
   string svrdate = Year()+"."+Month()+"."+Day();

   if(mondayfilter){
      nmondayhour=mondayhour+(gmtshift);if(nmondayhour>23)nmondayhour=nmondayhour-24;
      if(nmondayhour<10)imondayhour="0"+nmondayhour;
      if(nmondayhour>9)imondayhour=nmondayhour;
      if(mondayminute<10)imondayminute="0"+mondayminute;
      if(mondayminute>9)imondayminute=mondayminute;
      tmonday=StrToTime(svrdate+" "+imondayhour+":"+imondayminute);
   }
   if(weekfilter){
      nstarthour=starthour+(gmtshift);if(nstarthour>23)nstarthour=nstarthour-24;
      if(nstarthour<10)istarthour="0"+nstarthour;
      if(nstarthour>9)istarthour=nstarthour;
      if(startminute<10)istartminute="0"+startminute;
      if(startminute>9)istartminute=startminute;
      tstart=StrToTime(svrdate+" "+istarthour+":"+istartminute);

      nendhour=endhour+(gmtshift);if(nendhour>23)nendhour=nendhour-24;
      if(endhour<10)iendhour="0"+nendhour;
      if(endhour>9)iendhour=nendhour;
      if(endminute<10)iendminute="0"+endminute;
      if(endminute>9)iendminute=endminute;
      tend=StrToTime(svrdate+" "+iendhour+":"+iendminute);
   }
   if(fridayfilter){
      nfridayhour=fridayhour+(gmtshift);if(nfridayhour>23)nfridayhour=nfridayhour-24;
      if(nfridayhour<10)ifridayhour="0"+nfridayhour;
      if(nfridayhour>9)ifridayhour=nfridayhour;
      if(fridayminute<10)ifridayminute="0"+fridayminute;
      if(fridayminute>9)ifridayminute=fridayminute;
      tfriday=StrToTime(svrdate+" "+ifridayhour+":"+ifridayminute);
   }
   if(nstarthour>nendhour && TimeCurrent()<tstart && TimeCurrent()>tend)time="DONT TRADE";else time="TRADE";
   //Comment("\nCurrentTime = "+TimeCurrent(),"\ntstart = "+tstart,"\ntend = "+tend,"\nTimeFilter = "+time);
   if((weekfilter && (nstarthour<=nendhour && TimeCurrent()<tstart || TimeCurrent()>tend) || (nstarthour>nendhour && TimeCurrent()<tstart && TimeCurrent()>tend))
   || (tradesunday==false && DayOfWeek()==0) || (fridayfilter && DayOfWeek()==5 && TimeCurrent()>tfriday) || (mondayfilter && DayOfWeek()==1 && TimeCurrent()<tmonday))return(0);
   return(1);
}
*/
//|---------counter

int count(int type){
   cnt=0;
   if(OrdersTotal()>0){
      for(i=OrdersTotal();i>=0;i--){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderType()==type && OrderMagicNumber()==magic)cnt++;
      }
      return(cnt);
   }
}

//|---------close

void closebuy(){
   RefreshRates();
   if(OrdersTotal()>0){
      for(i=OrdersTotal();i>=0;i--){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderType()==OP_BUY){
            OrderClose(OrderTicket(),OrderLots(),Bid,slippage*mt);
         }
      }
   }
}

void closesell(){
   RefreshRates();
   if(OrdersTotal()>0){
      for(i=OrdersTotal();i>=0;i--){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderType()==OP_SELL){
            OrderClose(OrderTicket(),OrderLots(),Ask,slippage*mt);
         }
      }
   }
}

void hideclosebuy(){
   RefreshRates();
   if(OrdersTotal()>0){
      for(i=OrdersTotal();i>=0;i--){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderType()==OP_BUY
         && (hidesl && stoploss>0 && OrderProfit()<=(-1)*stoploss*OrderLots()*10-MarketInfo(Symbol(),MODE_SPREAD)*OrderLots()*10/mt)
         || (hidetp && takeprofit>0 && OrderProfit()>=takeprofit*OrderLots()*10)){
            OrderClose(OrderTicket(),OrderLots(),Bid,slippage*mt);
         }
      }
   }
}

void hideclosesell(){
   RefreshRates();
   if(OrdersTotal()>0){
      for(i=OrdersTotal();i>=0;i--){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderType()==OP_SELL
         && (hidesl && stoploss>0 && OrderProfit()<=(-1)*stoploss*OrderLots()*10-MarketInfo(Symbol(),MODE_SPREAD)*OrderLots()*10/mt)
         || (hidetp && takeprofit>0 && OrderProfit()>=takeprofit*OrderLots()*10)){
            OrderClose(OrderTicket(),OrderLots(),Ask,slippage*mt);
         }
      }
   }
}

//|---------breakeven

void movebreakeven(double breakevengain,double breakeven){
   RefreshRates();
   if(OrdersTotal()>0){
      for(i=OrdersTotal();i>=0;i--){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==magic){
            if(OrderType()==OP_BUY){
               if(NormalizeDouble((Bid-OrderOpenPrice()),dg)>=NormalizeDouble(breakevengain*pt,dg)){
                  if((NormalizeDouble((OrderStopLoss()-OrderOpenPrice()),dg)<NormalizeDouble(breakeven*pt,dg)) || OrderStopLoss()==0){
                     OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()+breakeven*pt,dg),OrderTakeProfit(),0,Blue);
                     return(0);
                  }
               }
            }
            else{
               if(NormalizeDouble((OrderOpenPrice()-Ask),dg)>=NormalizeDouble(breakevengain*pt,dg)){
                  if((NormalizeDouble((OrderOpenPrice()-OrderStopLoss()),dg)<NormalizeDouble(breakeven*pt,dg)) || OrderStopLoss()==0){
                     OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()-breakeven*pt,dg),OrderTakeProfit(),0,Red);
                     return(0);
                  }
               }
            }
         }
      }
   }
}

//|---------trailingstop

void movetrailingstop(double trailingstart,double trailingstop){
   RefreshRates();
   if(OrdersTotal()>0){
      for(i=OrdersTotal();i>=0;i--){
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==magic){
            if(OrderType()==OP_BUY){
               if(NormalizeDouble(Ask,dg)>NormalizeDouble(OrderOpenPrice()+trailingstart*pt,dg)
               && NormalizeDouble(OrderStopLoss(),dg)<NormalizeDouble(Bid-(trailingstop+trailingstep)*pt,dg)){
                  OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Bid-trailingstop*pt,dg),OrderTakeProfit(),0,Blue);
                  return(0);
               }
            }
            else{
               if(NormalizeDouble(Bid,dg)<NormalizeDouble(OrderOpenPrice()-trailingstart*pt,dg)
               && (NormalizeDouble(OrderStopLoss(),dg)>(NormalizeDouble(Ask+(trailingstop+trailingstep)*pt,dg))) || (OrderStopLoss()==0)){                 
                  OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Ask+trailingstop*pt,dg),OrderTakeProfit(),0,Red);
                  return(0);
               }
            }
         }
      }
   }
}

//|---------trailingprofit

void movetrailingprofit(double trailingstart,double trailingprofit){
   RefreshRates();
   for(int i=0;i<OrdersTotal();i++){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(OrderSymbol()==Symbol()&& OrderMagicNumber()==magic){
            if(OrderType()==OP_BUY){
               if(NormalizeDouble(Bid-OrderOpenPrice(),dg)<=NormalizeDouble((-1)*trailingstart*pt,dg)){
                  if(NormalizeDouble(OrderTakeProfit(),dg)>NormalizeDouble(Bid+(trailingprofit+trailingstep)*pt,dg) || NormalizeDouble(OrderTakeProfit(),dg)==0){
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),NormalizeDouble(Bid+trailingprofit*pt,dg),0,Blue);
                  }
               }
            }
            if(OrderType()==OP_SELL){
               if(NormalizeDouble(OrderOpenPrice()-Ask,dg)<=NormalizeDouble((-1)*trailingstart*pt,dg)){
                  if(NormalizeDouble(OrderTakeProfit(),dg)<NormalizeDouble(Ask-(trailingprofit+trailingstep)*pt,dg)){
                     OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),NormalizeDouble(Ask-trailingprofit*pt,dg),0,Red);
                  }
               }
            }
         }
      }
   }
}

void createlstoploss(double stoploss){
   RefreshRates();
   for(int i=0;i<OrdersTotal();i++){
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==magic){
         if(OrderType()==OP_BUY){
            if(OrderStopLoss()==0){                 
               OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Ask-stoploss*pt,dg),OrderTakeProfit(),0,Red);
               return(0);
            }
         }
      }
   }
}

void createsstoploss(double stoploss){
   RefreshRates();
   for(int i=0;i<OrdersTotal();i++){
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==magic){
         if(OrderType()==OP_SELL){
            if(OrderStopLoss()==0){                 
               OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(Bid+stoploss*pt,dg),OrderTakeProfit(),0,Red);
               return(0);
            }
         }
      }
   }
}

void createltakeprofit(double takeprofit){
   RefreshRates();
   for(int i=0;i<OrdersTotal();i++){
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==magic){
         if(OrderType()==OP_BUY){
            if(OrderTakeProfit()==0){                 
               OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),NormalizeDouble(Ask+takeprofit*pt,dg),0,Red);
               return(0);
            }
         }
      }
   }
}

void createstakeprofit(double takeprofit){
   RefreshRates();
   int total=OrdersTotal();
   for(int i=0;i<OrdersTotal();i++){
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==magic){
         if(OrderType()==OP_SELL){
            if(OrderTakeProfit()==0){                 
               OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),NormalizeDouble(Bid-takeprofit*pt,dg),0,Red);
               return(0);
            }
         }
      }
   }
}
/*
//|---------basket

bool closebasketpercent(double profit,double loss){
   double ipf,ilo;
   ipf=profit*(0.01*AccountBalance());
   ilo=loss*(0.01*AccountBalance());
   cb=AccountEquity()-AccountBalance();
   if(cb>=ipf || cb<=(ilo*(-1)))return(1);
   return(0);
}

//|---------delete

void delete(int type){
   if(OrdersTotal()>0){
      for(i=OrdersTotal();i>=0;i--){
        OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
        if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic && OrderType()==type){
          OrderDelete(OrderTicket());
        }   
      }
   }
}*/
/*
//|---------error

string errordescription(int code){
   string error;
   switch(code){
      case 0:
      case 1:error="no error";break;
      case 2:error="common error";break;
      case 3:error="invalid trade parameters";break;
      case 4:error="trade server is busy";break;
      case 5:error="old version of the client terminal";break;
      case 6:error="no connection with trade server";break;
      case 7:error="not enough rights";break;
      case 8:error="too frequent requests";break;
      case 9:error="malfunctional trade operation";break;
      case 64:error="account disabled";break;
      case 65:error="invalid account";break;
      case 128:error="trade timeout";break;
      case 129:error="invalid price";break;
      case 130:error="invalid stops";break;
      case 131:error="invalid trade volume";break;
      case 132:error="market is closed";break;
      case 133:error="trade is disabled";break;
      case 134:error="not enough money";break;
      case 135:error="price changed";break;
      case 136:error="off quotes";break;
      case 137:error="broker is busy";break;
      case 138:error="requote";break;
      case 139:error="order is locked";break;
      case 140:error="long positions only allowed";break;
      case 141:error="too many requests";break;
      case 145:error="modification denied because order too close to market";break;
      case 146:error="trade context is busy";break;
      case 4000:error="no error";break;
      case 4001:error="wrong function pointer";break;
      case 4002:error="array index is out of range";break;
      case 4003:error="no memory for function call stack";break;
      case 4004:error="recursive stack overflow";break;
      case 4005:error="not enough stack for parameter";break;
      case 4006:error="no memory for parameter string";break;
      case 4007:error="no memory for temp string";break;
      case 4008:error="not initialized string";break;
      case 4009:error="not initialized string in array";break;
      case 4010:error="no memory for array\' string";break;
      case 4011:error="too long string";break;
      case 4012:error="remainder from zero divide";break;
      case 4013:error="zero divide";break;
      case 4014:error="unknown command";break;
      case 4015:error="wrong jump (never generated error)";break;
      case 4016:error="not initialized array";break;
      case 4017:error="dll calls are not allowed";break;
      case 4018:error="cannot load library";break;
      case 4019:error="cannot call function";break;
      case 4020:error="expert function calls are not allowed";break;
      case 4021:error="not enough memory for temp string returned from function";break;
      case 4022:error="system is busy (never generated error)";break;
      case 4050:error="invalid function parameters count";break;
      case 4051:error="invalid function parameter value";break;
      case 4052:error="string function internal error";break;
      case 4053:error="some array error";break;
      case 4054:error="incorrect series array using";break;
      case 4055:error="custom indicator error";break;
      case 4056:error="arrays are incompatible";break;
      case 4057:error="global variables processing error";break;
      case 4058:error="global variable not found";break;
      case 4059:error="function is not allowed in testing mode";break;
      case 4060:error="function is not confirmed";break;
      case 4061:error="send mail error";break;
      case 4062:error="string parameter expected";break;
      case 4063:error="integer parameter expected";break;
      case 4064:error="double parameter expected";break;
      case 4065:error="array as parameter expected";break;
      case 4066:error="requested history data in update state";break;
      case 4099:error="end of file";break;
      case 4100:error="some file error";break;
      case 4101:error="wrong file name";break;
      case 4102:error="too many opened files";break;
      case 4103:error="cannot open file";break;
      case 4104:error="incompatible access to a file";break;
      case 4105:error="no order selected";break;
      case 4106:error="unknown symbol";break;
      case 4107:error="invalid price parameter for trade function";break;
      case 4108:error="invalid ticket";break;
      case 4109:error="trade is not allowed";break;
      case 4110:error="longs are not allowed";break;
      case 4111:error="shorts are not allowed";break;
      case 4200:error="object is already exist";break;
      case 4201:error="unknown object property";break;
      case 4202:error="object is not exist";break;
      case 4203:error="unknown object type";break;
      case 4204:error="no object name";break;
      case 4205:error="object coordinates error";break;
      case 4206:error="no specified subwindow";break;
      default:error="unknown error";
   }
   return(error);
}
*/